#include "PLA.h"
#ifndef min3
#define min3(x, y, z)        min(min(x, y), z)
#endif

#ifndef PLASUM
#define PLASUM(datatype) ( datatype == MPI_DOUBLE_COMPLEX ? PLA_SUM : MPI_SUM)
#endif
/*****************************************************************************/
int PLA_Trmm_left_lower_notrans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          bottom_owner, right_owner, bottom_size, right_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_cols = NULL,
            triangular_dup_a_cols = NULL,
            general_dup_a_cols = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_rows = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &triangular_source_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &general_source_a);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &triangular_target_b);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &general_target_b);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_a_cols);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_b_rows);

   PLA_Obj_horz_split_2(duplicated_a_cols, length_a, PLA_DUMMY,
                                                     &triangular_dup_a_cols);
   PLA_Obj_horz_split_2(duplicated_a_cols, length_a, PLA_DUMMY,
                                                     &general_dup_a_cols);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &triangular_target_b);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &general_target_b);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &general_source_b);
   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_ROW);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_RIGHT, &right_size, &right_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_BOTTOM, &bottom_size, &bottom_owner);
      if(0 == (size = min3(nb_alg,right_size, bottom_size))) break;
      PLA_Obj_view_shift( measure_square_a,        0,
                                            0,           -size,
                                                 -size);

      PLA_Obj_view_shift( triangular_source_a,          -size,
                                              -size,              -last_size,
                                                      -last_size);
      PLA_Obj_view_shift( general_source_a,           -last_size,
                                              -size,              -last_size,
                                                           0);

      PLA_Obj_view_shift( triangular_dup_a_cols,       -size,
                                                 0,              size-nb_alg,
                                                       -last_size);
      PLA_Obj_view_shift( general_dup_a_cols,          -last_size,
                                                 0,              size-nb_alg,
                                                           0);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,              -size,
                                                 0,                  0,
                                                       -last_size);
      PLA_Obj_view_shift( triangular_target_b,           -size,
                                                 0,                  0,
                                                       -last_size);
      PLA_Obj_view_shift( general_target_b,            -last_size,
                                                 0,                  0,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       size-nb_alg);
      PLA_Copy( triangular_source_a, triangular_dup_a_cols);
      PLA_Copy( general_source_a,    general_dup_a_cols);
      PLA_Copy( general_source_b,    duplicated_b_rows);
      PLA_Local_trmm(PLA_SIDE_LEFT, PLA_LOWER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_cols, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, general_dup_a_cols, duplicated_b_rows,
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_cols,          0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( general_dup_a_cols,              0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       nb_alg-size);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_cols );
   PLA_Obj_free( &triangular_dup_a_cols );
   PLA_Obj_free( &general_dup_a_cols );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_rows );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}
/******************************************************************************/
int PLA_Trmm_left_lower_trans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          top_owner, left_owner, top_size, left_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_cols = NULL,
            triangular_dup_a_cols = NULL,
            general_dup_a_cols = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_rows = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, 0, 0, &triangular_source_a, PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);
   PLA_Obj_split_4(a, 0, 0, &general_source_a,    PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_horz_split_2(b, 0, &triangular_target_b,
                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &general_target_b,
                              PLA_DUMMY);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_a_cols);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_b_rows);

   PLA_Obj_horz_split_2(duplicated_a_cols, 0, &triangular_dup_a_cols,
                                              PLA_DUMMY);
   PLA_Obj_horz_split_2(duplicated_a_cols, 0, &general_dup_a_cols,
                                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &triangular_target_b,
                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &general_target_b,
                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &general_source_b,
                              PLA_DUMMY);
   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_ROW);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_LEFT,&left_size,&left_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_TOP, &top_size, &top_owner);
      if(0 == (size = min3(nb_alg,left_size, top_size))) break;
      PLA_Obj_view_shift( measure_square_a,        size,
                                            size,           0,
                                                     0);
      PLA_Obj_view_shift( triangular_source_a,          last_size,
                                              last_size,              size,
                                                          size);
      PLA_Obj_view_shift( general_source_a,             last_size,
                                                  0,               last_size,
                                                          size);
      PLA_Obj_view_shift( triangular_dup_a_cols,        last_size,
                                                 0,               size-nb_alg,
                                                         size);
      PLA_Obj_view_shift( general_dup_a_cols,              0,
                                                 0,              size-nb_alg,
                                                        last_size);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,             last_size,
                                                 0,                  0,
                                                          size);
      PLA_Obj_view_shift( triangular_target_b,           last_size,
                                                 0,                  0,
                                                          size);
      PLA_Obj_view_shift( general_target_b,                 0,
                                                 0,                  0,
                                                        last_size);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       size-nb_alg);
      PLA_Copy( triangular_source_a, triangular_dup_a_cols);
      PLA_Copy( general_source_a,    general_dup_a_cols);
      PLA_Copy( general_source_b,    duplicated_b_rows);

      PLA_Local_trmm(PLA_SIDE_LEFT, PLA_UPPER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_cols, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, general_dup_a_cols, duplicated_b_rows,
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_cols,          0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( general_dup_a_cols,              0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       nb_alg-size);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_cols );
   PLA_Obj_free( &triangular_dup_a_cols );
   PLA_Obj_free( &general_dup_a_cols );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_rows );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

int PLA_Trmm_left_upper_notrans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          top_owner, left_owner, top_size, left_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_cols = NULL,
            triangular_dup_a_cols = NULL,
            general_dup_a_cols = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_rows = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, 0, 0, &triangular_source_a, PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);
   PLA_Obj_split_4(a, 0, 0, &general_source_a,    PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_horz_split_2(b, 0, &triangular_target_b,
                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &general_target_b,
                              PLA_DUMMY);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_a_cols);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_b_rows);

   PLA_Obj_horz_split_2(duplicated_a_cols, 0, &triangular_dup_a_cols,
                                              PLA_DUMMY);
   PLA_Obj_horz_split_2(duplicated_a_cols, 0, &general_dup_a_cols,
                                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &triangular_target_b,
                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &general_target_b,
                              PLA_DUMMY);
   PLA_Obj_horz_split_2(b, 0, &general_source_b,
                              PLA_DUMMY);
   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_ROW);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_LEFT,&left_size,&left_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_TOP, &top_size, &top_owner);
      if(0 == (size = min3(nb_alg,left_size, top_size))) break;
      PLA_Obj_view_shift( measure_square_a,        size,
                                            size,           0,
                                                     0);

      PLA_Obj_view_shift( triangular_source_a,          last_size,
                                              last_size,              size,
                                                          size);
      PLA_Obj_view_shift( general_source_a,                0,
                                              last_size,           size,
                                                       last_size);
      PLA_Obj_view_shift( triangular_dup_a_cols,        last_size,
                                                 0,               size-nb_alg,
                                                         size);
      PLA_Obj_view_shift( general_dup_a_cols,              0,
                                                 0,              size-nb_alg,
                                                        last_size);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,             last_size,
                                                 0,                  0,
                                                          size);
      PLA_Obj_view_shift( triangular_target_b,           last_size,
                                                 0,                  0,
                                                          size);
      PLA_Obj_view_shift( general_target_b,                 0,
                                                 0,                  0,
                                                        last_size);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       size-nb_alg);
      PLA_Copy( triangular_source_a, triangular_dup_a_cols);
      PLA_Copy( general_source_a,    general_dup_a_cols);
      PLA_Copy( general_source_b,    duplicated_b_rows);

      PLA_Local_trmm(PLA_SIDE_LEFT, PLA_UPPER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_cols, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, general_dup_a_cols, duplicated_b_rows,
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_cols,          0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( general_dup_a_cols,              0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       nb_alg-size);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_cols );
   PLA_Obj_free( &triangular_dup_a_cols );
   PLA_Obj_free( &general_dup_a_cols );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_rows );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

int PLA_Trmm_left_upper_trans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          bottom_owner, right_owner, bottom_size, right_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_cols = NULL,
            triangular_dup_a_cols = NULL,
            general_dup_a_cols = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_rows = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &triangular_source_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &general_source_a);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &triangular_target_b);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &general_target_b);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_a_cols);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_b_rows);

   PLA_Obj_horz_split_2(duplicated_a_cols, length_a, PLA_DUMMY,
                                                     &triangular_dup_a_cols);
   PLA_Obj_horz_split_2(duplicated_a_cols, length_a, PLA_DUMMY,
                                                     &general_dup_a_cols);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &triangular_target_b);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &general_target_b);
   PLA_Obj_horz_split_2(b, length_a, PLA_DUMMY,
                                     &general_source_b);
   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_ROW);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_RIGHT, &right_size, &right_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_BOTTOM, &bottom_size, &bottom_owner);
      if(0 == (size = min3(nb_alg,right_size, bottom_size))) break;
      PLA_Obj_view_shift( measure_square_a,        0,
                                            0,           -size,
                                                 -size);

      PLA_Obj_view_shift( triangular_source_a,          -size,
                                              -size,              -last_size,
                                                      -last_size);
      PLA_Obj_view_shift( general_source_a,             -size,
                                              -last_size,             0,
                                                        -last_size);

      PLA_Obj_view_shift( triangular_dup_a_cols,       -size,
                                                 0,              size-nb_alg,
                                                       -last_size);
      PLA_Obj_view_shift( general_dup_a_cols,          -last_size,
                                                 0,              size-nb_alg,
                                                           0);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,              -size,
                                                 0,                  0,
                                                       -last_size);
      PLA_Obj_view_shift( triangular_target_b,           -size,
                                                 0,                  0,
                                                       -last_size);
      PLA_Obj_view_shift( general_target_b,            -last_size,
                                                 0,                  0,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       size-nb_alg);
      PLA_Copy( triangular_source_a, triangular_dup_a_cols);
      PLA_Copy( general_source_a,    general_dup_a_cols);
      PLA_Copy( general_source_b,    duplicated_b_rows);

      PLA_Local_trmm(PLA_SIDE_LEFT, PLA_LOWER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_cols, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, general_dup_a_cols, duplicated_b_rows,
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_cols,          0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( general_dup_a_cols,              0,
                                                 0,              nb_alg-size,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_rows,               0,
                                                 0,                  0,
                                                       nb_alg-size);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_cols );
   PLA_Obj_free( &triangular_dup_a_cols );
   PLA_Obj_free( &general_dup_a_cols );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_rows );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

int PLA_Trmm_right_lower_notrans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          top_owner, left_owner, top_size, left_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_rows = NULL,
            triangular_dup_a_rows = NULL,
            general_dup_a_rows = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_cols = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, 0, 0, &triangular_source_a, PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);
   PLA_Obj_split_4(a, 0, 0, &general_source_a,    PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_vert_split_2(b, 0, &triangular_target_b, PLA_DUMMY);
   PLA_Obj_vert_split_2(b, 0, &general_target_b,     PLA_DUMMY);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_a_rows);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_b_cols);

   PLA_Obj_vert_split_2(duplicated_a_rows, 0, &triangular_dup_a_rows,PLA_DUMMY);
   PLA_Obj_vert_split_2(duplicated_a_rows, 0, &general_dup_a_rows, PLA_DUMMY);

   PLA_Obj_vert_split_2(b, 0, &triangular_target_b, PLA_DUMMY);
   PLA_Obj_vert_split_2(b, 0, &general_target_b, PLA_DUMMY);
   PLA_Obj_vert_split_2(b, 0, &general_source_b, PLA_DUMMY);

   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_COL);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_LEFT,&left_size,&left_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_TOP, &top_size, &top_owner);
      if(0 == (size = min3(nb_alg,left_size, top_size))) break;
      PLA_Obj_view_shift( measure_square_a,        size,
                                            size,           0,
                                                     0);

      PLA_Obj_view_shift( triangular_source_a,          last_size,
                                              last_size,              size,
                                                          size);
      PLA_Obj_view_shift( general_source_a,             last_size,
                                                  0,               last_size,
                                                          size);
      PLA_Obj_view_shift( triangular_dup_a_rows,            0,
                                                last_size,               size,
                                                         size-nb_alg);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                                 0,              last_size,
                                                        size-nb_alg);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,                 0,
                                                 last_size,           size,
                                                            0);
      PLA_Obj_view_shift( triangular_target_b,              0,
                                                 last_size,               size,
                                                            0);
      PLA_Obj_view_shift( general_target_b,                 0,
                                                 0,                  last_size,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                 size-nb_alg,
                                                           0);
      PLA_Copy( triangular_source_a, triangular_dup_a_rows);
      PLA_Copy( general_source_a,    general_dup_a_rows);
      PLA_Copy( general_source_b,    duplicated_b_cols);

      PLA_Local_trmm(PLA_SIDE_RIGHT, PLA_LOWER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_rows, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, duplicated_b_cols, general_dup_a_rows, 
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_rows,           0,
                                                 0,              0,
                                                       nb_alg-size);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                                 0,              0,
                                                       nb_alg-size);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                 nb_alg-size,
                                                           0);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_rows );
   PLA_Obj_free( &triangular_dup_a_rows );
   PLA_Obj_free( &general_dup_a_rows );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_cols );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

int PLA_Trmm_right_lower_trans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          bottom_owner, right_owner, bottom_size, right_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_rows = NULL,
            triangular_dup_a_rows = NULL,
            general_dup_a_rows = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_cols = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &triangular_source_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &general_source_a);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &triangular_target_b);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &general_target_b);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_a_rows);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_b_cols);

   PLA_Obj_vert_split_2(duplicated_a_rows, length_a, PLA_DUMMY, &triangular_dup_a_rows);
   PLA_Obj_vert_split_2(duplicated_a_rows, length_a, PLA_DUMMY, &general_dup_a_rows);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &triangular_target_b);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &general_target_b);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &general_source_b);
   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_COL);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_RIGHT, &right_size, &right_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_BOTTOM, &bottom_size, &bottom_owner);
      if(0 == (size = min3(nb_alg,right_size, bottom_size))) break;
      PLA_Obj_view_shift( measure_square_a,        0,
                                            0,           -size,
                                                 -size);

      PLA_Obj_view_shift( triangular_source_a,          -size,
                                              -size,              -last_size,
                                                      -last_size);
      PLA_Obj_view_shift( general_source_a,             -last_size,
                                              -size,             -last_size,
                                                           0);

      PLA_Obj_view_shift( triangular_dup_a_rows,          0,
                                                 -size,              -last_size,
                                                       size-nb_alg);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                              -last_size,              0,
                                                        size-nb_alg);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,                 0,
                                                 -size,             -last_size,
                                                            0);
      PLA_Obj_view_shift( triangular_target_b,             0,
                                                 -size,              -last_size,
                                                           0);
      PLA_Obj_view_shift( general_target_b,                0,
                                              -last_size,                  0,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                 size-nb_alg,
                                                           0);
      PLA_Copy( triangular_source_a, triangular_dup_a_rows);
      PLA_Copy( general_source_a,    general_dup_a_rows);
      PLA_Copy( general_source_b,    duplicated_b_cols);

      PLA_Local_trmm(PLA_SIDE_RIGHT, PLA_UPPER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_rows, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, duplicated_b_cols, general_dup_a_rows, 
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_rows,          0,
                                                 0,                 0,
                                                      nb_alg-size);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                                 0,                 0,
                                                      nb_alg-size);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                  nb_alg-size,
                                                           0);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_rows );
   PLA_Obj_free( &triangular_dup_a_rows );
   PLA_Obj_free( &general_dup_a_rows );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_cols );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

int PLA_Trmm_right_upper_notrans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          bottom_owner, right_owner, bottom_size, right_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_rows = NULL,
            triangular_dup_a_rows = NULL,
            general_dup_a_rows = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_cols = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &triangular_source_a);
   PLA_Obj_split_4(a, length_a, width_a, PLA_DUMMY, PLA_DUMMY,
                                         PLA_DUMMY, &general_source_a);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &triangular_target_b);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &general_target_b);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_a_rows);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_b_cols);

   PLA_Obj_vert_split_2(duplicated_a_rows, length_a, PLA_DUMMY, &triangular_dup_a_rows);
   PLA_Obj_vert_split_2(duplicated_a_rows, length_a, PLA_DUMMY, &general_dup_a_rows);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &triangular_target_b);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &general_target_b);
   PLA_Obj_vert_split_2(b, length_a, PLA_DUMMY, &general_source_b);
   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_ROW);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_COL);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_RIGHT, &right_size, &right_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_BOTTOM, &bottom_size, &bottom_owner);
      if(0 == (size = min3(nb_alg,right_size, bottom_size))) break;
      PLA_Obj_view_shift( measure_square_a,        0,
                                            0,           -size,
                                                 -size);

      PLA_Obj_view_shift( triangular_source_a,          -size,
                                              -size,              -last_size,
                                                      -last_size);
      PLA_Obj_view_shift( general_source_a,             -size,
                                              -last_size,           0,
                                                       -last_size);

      PLA_Obj_view_shift( triangular_dup_a_rows,          0,
                                                 -size,              -last_size,
                                                       size-nb_alg);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                              -last_size,              0,
                                                        size-nb_alg);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,                 0,
                                                 -size,             -last_size,
                                                            0);
      PLA_Obj_view_shift( triangular_target_b,             0,
                                                 -size,              -last_size,
                                                           0);
      PLA_Obj_view_shift( general_target_b,                0,
                                              -last_size,                  0,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                 size-nb_alg,
                                                           0);
      PLA_Copy( triangular_source_a, triangular_dup_a_rows);
      PLA_Copy( general_source_a,    general_dup_a_rows);
      PLA_Copy( general_source_b,    duplicated_b_cols);

      PLA_Local_trmm(PLA_SIDE_RIGHT, PLA_UPPER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_rows, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, duplicated_b_cols, general_dup_a_rows, 
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_rows,          0,
                                                 0,                 0,
                                                      nb_alg-size);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                                 0,                 0,
                                                      nb_alg-size);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                  nb_alg-size,
                                                           0);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_rows );
   PLA_Obj_free( &triangular_dup_a_rows );
   PLA_Obj_free( &general_dup_a_rows );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_cols );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

int PLA_Trmm_right_upper_trans_pp(int nb_alg, int diag,
                                   PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   int          idummy, length_a, width_a, size, last_size = 0;
   int          top_owner, left_owner, top_size, left_size;
   PLA_Template template;
   MPI_Datatype datatype;
   PLA_Obj  measure_square_a = NULL, /* used to determine triangles size */
            triangular_source_a = NULL,
            general_source_a = NULL,
            duplicated_a_rows = NULL,
            triangular_dup_a_rows = NULL,
            general_dup_a_rows = NULL,
            general_source_b = NULL,
            triangular_target_b = NULL,
            general_target_b = NULL,
            duplicated_b_cols = NULL,
            One = NULL  ;


   PLA_Obj_template(a, &template);
   PLA_Obj_datatype(a, &datatype);
   PLA_Mscalar_create(datatype,PLA_ALL_ROWS,PLA_ALL_COLS, 1, 1, template, &One);
   PLA_Obj_set_to_one(One);

   PLA_Obj_view_all( a, &measure_square_a);

   PLA_Obj_global_length(a, &length_a);
   PLA_Obj_global_width (a, &width_a);
   PLA_Obj_split_4(a, 0, 0, &triangular_source_a, PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);
   PLA_Obj_split_4(a, 0, 0, &general_source_a,    PLA_DUMMY,
                            PLA_DUMMY,            PLA_DUMMY);

/* Abuses the fact that length of A = width of A = length of B */
   PLA_Obj_vert_split_2(b, 0, &triangular_target_b, PLA_DUMMY);
   PLA_Obj_vert_split_2(b, 0, &general_target_b,     PLA_DUMMY);

   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_ROW, PLA_ALL_ROWS, nb_alg,
                                &duplicated_a_rows);
   PLA_Pmvector_create_conf_to( b, PLA_PROJ_ONTO_COL, PLA_ALL_COLS, nb_alg,
                                &duplicated_b_cols);

   PLA_Obj_vert_split_2(duplicated_a_rows, 0, &triangular_dup_a_rows,PLA_DUMMY);
   PLA_Obj_vert_split_2(duplicated_a_rows, 0, &general_dup_a_rows, PLA_DUMMY);

   PLA_Obj_vert_split_2(b, 0, &triangular_target_b, PLA_DUMMY);
   PLA_Obj_vert_split_2(b, 0, &general_target_b, PLA_DUMMY);
   PLA_Obj_vert_split_2(b, 0, &general_source_b, PLA_DUMMY);

   PLA_Obj_set_orientation(triangular_source_a, PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_a,    PLA_PROJ_ONTO_COL);
   PLA_Obj_set_orientation(general_source_b,    PLA_PROJ_ONTO_COL);
   while(TRUE)
   {
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_LEFT,&left_size,&left_owner);
      PLA_Obj_split_size( measure_square_a, PLA_SIDE_TOP, &top_size, &top_owner);
      if(0 == (size = min3(nb_alg,left_size, top_size))) break;
      PLA_Obj_view_shift( measure_square_a,        size,
                                            size,           0,
                                                     0);

      PLA_Obj_view_shift( triangular_source_a,          last_size,
                                              last_size,              size,
                                                          size);
      PLA_Obj_view_shift( general_source_a,                 0,
                                                  last_size,          size,
                                                          last_size);
      PLA_Obj_view_shift( triangular_dup_a_rows,            0,
                                                last_size,               size,
                                                         size-nb_alg);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                                 0,              last_size,
                                                        size-nb_alg);
/* Yes, triangular_target_b and source_b are the same -- names used for doc. */
      PLA_Obj_view_shift( general_source_b,                 0,
                                                 last_size,           size,
                                                            0);
      PLA_Obj_view_shift( triangular_target_b,              0,
                                                 last_size,               size,
                                                            0);
      PLA_Obj_view_shift( general_target_b,                 0,
                                                 0,                  last_size,
                                                           0);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                 size-nb_alg,
                                                           0);
      PLA_Copy( triangular_source_a, triangular_dup_a_rows);
      PLA_Copy( general_source_a,    general_dup_a_rows);
      PLA_Copy( general_source_b,    duplicated_b_cols);

      PLA_Local_trmm(PLA_SIDE_RIGHT, PLA_LOWER_TRIANGULAR, PLA_NO_TRANS, diag,
                     alpha, triangular_dup_a_rows, triangular_target_b);
      PLA_Local_gemm(PLA_NO_TRANS, PLA_NO_TRANS,
                     alpha, duplicated_b_cols, general_dup_a_rows, 
                     One,   general_target_b);
/* resize the buffers to original sizes -- the PMvectors */
      PLA_Obj_view_shift( triangular_dup_a_rows,           0,
                                                 0,              0,
                                                       nb_alg-size);
      PLA_Obj_view_shift( general_dup_a_rows,              0,
                                                 0,              0,
                                                       nb_alg-size);
      PLA_Obj_view_shift( duplicated_b_cols,               0,
                                                 0,                 nb_alg-size,
                                                           0);
      last_size = size;
   }
   PLA_Obj_free( &measure_square_a );
   PLA_Obj_free( &triangular_source_a );
   PLA_Obj_free( &general_source_a );
   PLA_Obj_free( &duplicated_a_rows );
   PLA_Obj_free( &triangular_dup_a_rows );
   PLA_Obj_free( &general_dup_a_rows );
   PLA_Obj_free( &general_source_b );
   PLA_Obj_free( &triangular_target_b );
   PLA_Obj_free( &general_target_b );
   PLA_Obj_free( &duplicated_b_cols );
   PLA_Obj_free( &One );
   return(PLA_SUCCESS);
}

/*****************************************************************************/
int PLA_Trmm(int side, int uplo,  int transa, int diag,
             PLA_Obj alpha, PLA_Obj a, PLA_Obj b )
{
   PLA_Obj alpha_dup = NULL;
   int nb_alg, owner_row, owner_col;
   PLA_Template template;

   PLA_Obj_template(a, &template);
   PLA_Environ_nb_alg(PLA_OP_PAN_PAN, template,  &nb_alg);

   PLA_Obj_owner_row(alpha, &owner_row);
   PLA_Obj_owner_col(alpha, &owner_col);
   if ( owner_row != PLA_ALL_ROWS || owner_col != PLA_ALL_COLS )
   {
      PLA_Mscalar_create_conf_to( alpha,PLA_ALL_ROWS, PLA_ALL_COLS,&alpha_dup);
      PLA_Copy( alpha, alpha_dup );
   }
   if( PLA_SIDE_LEFT == side)
   {
      if(PLA_LOWER_TRIANGULAR == uplo)
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trmm_left_lower_notrans_pp(nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
         else
            PLA_Trmm_left_lower_trans_pp  (nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
      }
      else
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trmm_left_upper_notrans_pp(nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
         else
            PLA_Trmm_left_upper_trans_pp  (nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
      }
   }
   else /* ( PLA_SIDE_RIGHT == side) */
   {
      if(PLA_LOWER_TRIANGULAR == uplo)
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trmm_right_lower_notrans_pp(nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
         else
            PLA_Trmm_right_lower_trans_pp  (nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
      }
      else
      {
         if(PLA_NO_TRANSPOSE == transa)
            PLA_Trmm_right_upper_notrans_pp(nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
         else
            PLA_Trmm_right_upper_trans_pp  (nb_alg, diag,
                                           alpha_dup == NULL ? alpha:alpha_dup,
                                           a, b);
      }
   }
   PLA_Obj_free( &alpha_dup );
   return PLA_SUCCESS;
}
