#include "PLA.h"

int PLA_copy_obj_dupl_mscal ( PLA_Obj Aobj, PLA_Obj Bobj )
{
   int loc_len, loc_wid, ldim,
       nrows, ncols,
       glob_len, glob_wid, align_row, align_col,
       proc_row, proc_col, num_proc_row, root;
   int project, owner_row, owner_col;
   void * buffer;
   MPI_Comm comm1d;
   MPI_Datatype datatype;
   PLA_Obj_obj_type objtype;
   PLA_Template template;

   PLA_Obj_local_length ( Aobj, & loc_len );
   PLA_Obj_local_width ( Aobj, & loc_wid );

   PLA_Obj_local_buffer ( Bobj, & buffer );
   PLA_Obj_local_ldim ( Bobj, & ldim );

   if ( loc_len > 0 && loc_wid > 0 )
      PLA_Obj_extract_contents ( Aobj, ldim, 1, & nrows, & ncols, buffer );

   PLA_Obj_objtype(Aobj,  &objtype); 
   PLA_Obj_datatype(Aobj, &datatype);
   PLA_Obj_template(Aobj, &template);

   PLA_Obj_global_info ( Aobj, & glob_len, & glob_wid, 
                         & project, & owner_row, & owner_col,
                         & align_row, & align_col);

   switch ( objtype )
   {
      case PLA_MATRIX :

         PLA_Temp_matrix_owner_rowcol ( template, align_row, align_col,
                                       & proc_row, & proc_col );
         PLA_Temp_comm_col_size ( template, & num_proc_row );
         root = proc_col * num_proc_row + proc_row;
         break;

      case PLA_MVECTOR :
      case PLA_VECTOR :

         PLA_Temp_vector_owner_rank ( template, align_row, & root );
         break;

      default :

         printf ( "Invalid object type in PLA_copy_obj_dupl_mscal\n" );
   }


   PLA_Temp_comm1D ( template, & comm1d );
   PLA_Obj_local_length ( Bobj, & loc_len );
   PLA_Obj_local_width ( Bobj, & loc_wid );

   MPI_Bcast ( buffer, loc_len * loc_wid, datatype, root, comm1d );

   return ( 0 );
}
