/***************************************************************************
  20 June 1996 1:00pm
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:
  Robert van de Geijn, Department of Computer Sciences
  University of Texas at Austin  78712.    rvdg@cs.utexas.edu

***************************************************************************/



#if MANUFACTURE == CRAY
#include <string.h>
#include <fortran.h>
#endif

#if     MACHINE_TYPE == PARAGON || MANUFACTURE == SUN || MANUFACTURE == PC
  #define PLA_CP2FCD( name ) name
  #define PLA_FOR2C( name ) name ## _
#elif MACHINE_TYPE == SP2
  #define PLA_CP2FCD( name ) name
  #define PLA_FOR2C( name ) name
#elif MANUFACTURE == CRAY
  #define PLA_CP2FCD( name ) _cptofcd ( name, strlen ( name ) )
  #define PLA_FOR2C( name ) name
#endif

/*
 * Level 1 BLAS
 */


#if MANUFACTURE == INTEL || MANUFACTURE == IBM || MANUFACTURE == SUN || MANUFACTURE == PC

  /*
   * Single precision
   */

  #define PLA_srotg( a, b, c, s )                         PLA_FOR2C ( srotg  ) ( a, b, c, s )
  #define PLA_srot(   n,        x, incx, y, incy, c, s )  PLA_FOR2C ( srot   ) ( n,        x, incx, y, incy, c, s )
  #define PLA_sswap(  n,        x, incx, y, incy )        PLA_FOR2C ( sswap  ) ( n,        x, incx, y, incy )
  #define PLA_scopy(  n,        x, incx, y, incy )        PLA_FOR2C ( scopy  ) ( n,        x, incx, y, incy )
  #define PLA_saxpy(  n, alpha, x, incx, y, incy )        PLA_FOR2C ( saxpy  ) ( n, alpha, x, incx, y, incy )
  #define PLA_sscal(  n, alpha, x, incx)                  PLA_FOR2C ( sscal  ) ( n, alpha, x, incx)
  #define PLA_sdot(   n,        x, incx, y, incy )        PLA_FOR2C ( sdot   ) ( n,        x, incx, y, incy )
  #define PLA_snrm2(  n,        x, incx )                 PLA_FOR2C ( snrm2  ) ( n,        x, incx )
  #define PLA_sasum(  n,        x, incx )                 PLA_FOR2C ( sasum  ) ( n,        x, incx )
  #define PLA_isamax( n,        x, incx )                 PLA_FOR2C ( isamax ) ( n,        x, incx )

  #define PLA_slacpy( u, m, n, a, lda, b, ldb )           PLA_FOR2C ( slacpy ) ( u, m, n, a, lda, b, ldb)

  /*
   * Double precision
   */
  #define PLA_drotg( a, b, c, s )                         PLA_FOR2C ( drotg  ) ( a, b, c, s )
  #define PLA_drot(   n,        x, incx, y, incy, c, s )  PLA_FOR2C ( drot   ) ( n,        x, incx, y, incy, c, s )
  #define PLA_dswap(  n,        x, incx, y, incy )        PLA_FOR2C ( dswap  ) ( n,        x, incx, y, incy )
  #define PLA_dcopy(  n,        x, incx, y, incy )        PLA_FOR2C ( dcopy  ) ( n,        x, incx, y, incy )
  #define PLA_daxpy(  n, alpha, x, incx, y, incy )        PLA_FOR2C ( daxpy  ) ( n, alpha, x, incx, y, incy )
  #define PLA_dscal(  n, alpha, x, incx)                  PLA_FOR2C ( dscal  ) ( n, alpha, x, incx)
  #define PLA_ddot(   n,        x, incx, y, incy )        PLA_FOR2C ( ddot   ) ( n,        x, incx, y, incy )
  #define PLA_dnrm2(  n,        x, incx )                 PLA_FOR2C ( dnrm2  ) ( n,        x, incx )
  #define PLA_dasum(  n,        x, incx )                 PLA_FOR2C ( dasum  ) ( n,        x, incx )
  #define PLA_idamax( n,        x, incx )                 PLA_FOR2C ( idamax ) ( n,        x, incx )
 
  #define PLA_dlacpy( u, m, n, a, lda, b, ldb )           PLA_FOR2C ( dlacpy ) ( u, m, n, a, lda, b, ldb)

  /*
   * Single precision complex
   */
  #define PLA_cswap(  n,        x, incx, y, incy )        PLA_FOR2C ( cswap  ) ( n,        x, incx, y, incy )
  #define PLA_ccopy(  n,        x, incx, y, incy )        PLA_FOR2C ( ccopy  ) ( n,        x, incx, y, incy )
  #define PLA_caxpy(  n, alpha, x, incx, y, incy )        PLA_FOR2C ( caxpy  ) ( n, alpha, x, incx, y, incy )
  #define PLA_cscal(  n, alpha, x, incx)                  PLA_FOR2C ( cscal  ) ( n, alpha, x, incx)
  #define PLA_cdot(   n,        x, incx, y, incy )        PLA_FOR2C ( cdot   ) ( n,        x, incx, y, incy )
  #define PLA_cdotu(  n,        x, incx, y, incy )        PLA_FOR2C ( cdotu  ) ( n,        x, incx, y, incy )
  #define PLA_cdotc(  n,        x, incx, y, incy )        PLA_FOR2C ( cdotc  ) ( n,        x, incx, y, incy )
  #define PLA_cnrm2(  n,        x, incx )                 PLA_FOR2C ( cnrm2  ) ( n,        x, incx )
  #define PLA_casum(  n,        x, incx )                 PLA_FOR2C ( casum  ) ( n,        x, incx )
  #define PLA_icamax( n,        x, incx )                 PLA_FOR2C ( icamax ) ( n,        x, incx )

  #define PLA_clacpy( u, m, n, a, lda, b, ldb )           PLA_FOR2C ( clacpy ) ( u, m, n, a, lda, b, ldb)

  /*
   * Double precision complex
   */
  #define PLA_zswap(  n,        x, incx, y, incy )        PLA_FOR2C ( zswap  ) ( n,        x, incx, y, incy )
  #define PLA_zcopy(  n,        x, incx, y, incy )        PLA_FOR2C ( zcopy  ) ( n,        x, incx, y, incy )
  #define PLA_zaxpy(  n, alpha, x, incx, y, incy )        PLA_FOR2C ( zaxpy  ) ( n, alpha, x, incx, y, incy )
  #define PLA_zscal(  n, alpha, x, incx)                  PLA_FOR2C ( zscal  ) ( n, alpha, x, incx)
  #define PLA_zdot(   n,        x, incx, y, incy )        PLA_FOR2C ( zdot   ) ( n,        x, incx, y, incy )
  #define PLA_zdotu(  n,        x, incx, y, incy )        PLA_FOR2C ( zdotu  ) ( n,        x, incx, y, incy )
  #define PLA_zdotc(  n,        x, incx, y, incy )        PLA_FOR2C ( zdotc  ) ( n,        x, incx, y, incy )
  #define PLA_znrm2(  n,        x, incx )                 PLA_FOR2C ( znrm2  ) ( n,        x, incx )
  #define PLA_zasum(  n,        x, incx )                 PLA_FOR2C ( zasum  ) ( n,        x, incx )
  #define PLA_izamax( n,        x, incx )                 PLA_FOR2C ( izamax ) ( n,        x, incx )

  #define PLA_zlacpy( u, m, n, a, lda, b, ldb )           PLA_FOR2C ( zlacpy ) ( u, m, n, a, lda, b, ldb)

#elif MANUFACTURE == CRAY

  /*
   * Single precision
   */

  #define PLA_srotg( a, b, c, s )                         SROTG  ( a, b, c, s )
  #define PLA_srot(   n,        x, incx, y, incy, c, s )  SROT   ( n,        x, incx, y, incy, c, s )
  #define PLA_sswap(  n,        x, incx, y, incy )        SSWAP  ( n,        x, incx, y, incy )
  #define PLA_scopy(  n,        x, incx, y, incy )        SCOPY  ( n,        x, incx, y, incy )
  #define PLA_saxpy(  n, alpha, x, incx, y, incy )        SAXPY  ( n, alpha, x, incx, y, incy )
  #define PLA_sscal(  n, alpha, x, incx)                  SSCAL  ( n, alpha, x, incx)
  #define PLA_sdot(   n,        x, incx, y, incy )        SDOT   ( n,        x, incx, y, incy )
  #define PLA_snrm2(  n,        x, incx )                 SNRM2  ( n,        x, incx )
  #define PLA_sasum(  n,        x, incx )                 SASUM  ( n,        x, incx )
  #define PLA_isamax( n,        x, incx )                 ISAMAX ( n,        x, incx )

  #define PLA_slacpy( u, m, n, a, lda, b, ldb )           SLACPY ( PLA_CP2FCD ( u ), m, n, a, lda, b, ldb)

  /*
   * Double precision
   */
  #define PLA_drotg( a, b, c, s )                         SROTG  ( a, b, c, s )
  #define PLA_drot(   n,        x, incx, y, incy, c, s )  SROT   ( n,        x, incx, y, incy, c, s )
  #define PLA_dswap(  n,        x, incx, y, incy )        SSWAP  ( n,        x, incx, y, incy )
  #define PLA_dcopy(  n,        x, incx, y, incy )        SCOPY  ( n,        x, incx, y, incy )
  #define PLA_daxpy(  n, alpha, x, incx, y, incy )        SAXPY  ( n, alpha, x, incx, y, incy )
  #define PLA_dscal(  n, alpha, x, incx)                  SSCAL  ( n, alpha, x, incx)
  #define PLA_ddot(   n,        x, incx, y, incy )        SDOT   ( n,        x, incx, y, incy )
  #define PLA_dnrm2(  n,        x, incx )                 SNRM2  ( n,        x, incx )
  #define PLA_dasum(  n,        x, incx )                 SASUM  ( n,        x, incx )
  #define PLA_idamax( n,        x, incx )                 ISAMAX ( n,        x, incx )

  #define PLA_dlacpy( u, m, n, a, lda, b, ldb )           SLACPY ( PLA_CP2FCD ( u ), m, n, a, lda, b, ldb)
   
  /*
   * Single precision complex
   */
  #define PLA_cswap(  n,        x, incx, y, incy )        CSWAP  ( n,        x, incx, y, incy )
  #define PLA_ccopy(  n,        x, incx, y, incy )        CCOPY  ( n,        x, incx, y, incy )
  #define PLA_caxpy(  n, alpha, x, incx, y, incy )        CAXPY  ( n, alpha, x, incx, y, incy )
  #define PLA_cscal(  n, alpha, x, incx)                  CSCAL  ( n, alpha, x, incx)
  #define PLA_cdot(   n,        x, incx, y, incy )        CDOT   ( n,        x, incx, y, incy )
  #define PLA_cdotu(  n,        x, incx, y, incy )        CDOTU  ( n,        x, incx, y, incy )
  #define PLA_cdotc(  n,        x, incx, y, incy )        CDOTC  ( n,        x, incx, y, incy )
  #define PLA_cnrm2(  n,        x, incx )                 CNRM2  ( n,        x, incx )
  #define PLA_casum(  n,        x, incx )                 CASUM  ( n,        x, incx )
  #define PLA_icamax( n,        x, incx )                 ICAMAX ( n,        x, incx )

  #define PLA_clacpy( u, m, n, a, lda, b, ldb )           CLACPY ( PLA_CP2FCD ( u ), m, n, a, lda, b, ldb)

  /*
   * Double precision complex
   */
  #define PLA_zswap(  n,        x, incx, y, incy )        CSWAP  ( n,        x, incx, y, incy )
  #define PLA_zcopy(  n,        x, incx, y, incy )        CCOPY  ( n,        x, incx, y, incy )
  #define PLA_zaxpy(  n, alpha, x, incx, y, incy )        CAXPY  ( n, alpha, x, incx, y, incy )
  #define PLA_zscal(  n, alpha, x, incx)                  CSCAL  ( n, alpha, x, incx)
  #define PLA_zdot(   n,        x, incx, y, incy )        CDOT   ( n,        x, incx, y, incy )
  #define PLA_zdotu(  n,        x, incx, y, incy )        CDOTU  ( n,        x, incx, y, incy )
  #define PLA_zdotc(  n,        x, incx, y, incy )        CDOTC  ( n,        x, incx, y, incy )
  #define PLA_znrm2(  n,        x, incx )                 CNRM2  ( n,        x, incx )
  #define PLA_zasum(  n,        x, incx )                 CASUM  ( n,        x, incx )
  #define PLA_izamax( n,        x, incx )                 ICAMAX ( n,        x, incx )

  #define PLA_zlacpy( u, m, n, a, lda, b, ldb )           CLACPY ( PLA_CP2FCD ( u ), m, n, a, lda, b, ldb)

#endif

/*
 * Level 2 BLAS
 */

#if MANUFACTURE == INTEL || MANUFACTURE == IBM || MANUFACTURE == SUN  || MANUFACTURE == PC
  /*
   * Single precision
   */

  #define            PLA_sgemv(           trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    sgemv  ) (       trans,       m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_ssymv(     uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    ssymv  ) ( uplo,                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_strmv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     strmv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )
  #define            PLA_strsv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     strsv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )

  #define           PLA_sger(            m, n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    sger ) (         m, n, alpha, x, incx, y, incy, a, lda )
  #define           PLA_ssyr(      uplo,    n, alpha, x, incx,          a, lda ) \
          PLA_FOR2C(    ssyr   ) ( uplo,    n, alpha, x, incx,          a, lda )
  #define           PLA_ssyr2(     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    ssyr2  ) ( uplo,    n, alpha, x, incx, y, incy, a, lda )

  /*
   * Double precision
   */

  #define            PLA_dgemv(           trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    dgemv  ) (       trans,       m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_dsymv(     uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    dsymv  ) ( uplo,                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_dtrmv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     dtrmv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )
  #define            PLA_dtrsv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     dtrsv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )

  #define           PLA_dger(            m, n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    dger ) (         m, n, alpha, x, incx, y, incy, a, lda )
  #define           PLA_dsyr(      uplo,    n, alpha, x, incx,          a, lda ) \
          PLA_FOR2C(    dsyr   ) ( uplo,    n, alpha, x, incx,          a, lda )
  #define           PLA_dsyr2(     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    dsyr2  ) ( uplo,    n, alpha, x, incx, y, incy, a, lda )

  /*
   * Single precision complex
   */
  #define            PLA_cgemv(           trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    cgemv  ) (       trans,       m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_chemv(     uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    chemv  ) ( uplo,                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_ctrmv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     ctrmv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )
  #define            PLA_ctrsv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     ctrsv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )

  #define           PLA_cger(            m, n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    cger ) (         m, n, alpha, x, incx, y, incy, a, lda )
  #define           PLA_cher(      uplo,    n, alpha, x, incx,          a, lda ) \
          PLA_FOR2C(    cher   ) ( uplo,    n, alpha, x, incx,          a, lda )
  #define           PLA_cher2(     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    cher2  ) ( uplo,    n, alpha, x, incx, y, incy, a, lda )

  /*
   * Double precision complex
   */
  #define            PLA_zgemv(           trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    zgemv  ) (       trans,       m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_zhemv(     uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
          PLA_FOR2C (    zhemv  ) ( uplo,                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define            PLA_ztrmv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     ztrmv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )
  #define            PLA_ztrsv(     uplo, trans, diag,    n,        a, lda, x, incx ) \
          PLA_FOR2C(     ztrsv  ) ( uplo, trans, diag,    n,        a, lda, x, incx )

  #define           PLA_zger(            m, n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    zger ) (         m, n, alpha, x, incx, y, incy, a, lda )
  #define           PLA_zher(      uplo,    n, alpha, x, incx,          a, lda ) \
          PLA_FOR2C(    zher   ) ( uplo,    n, alpha, x, incx,          a, lda )
  #define           PLA_zher2(     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
          PLA_FOR2C(    zher2  ) ( uplo,    n, alpha, x, incx, y, incy, a, lda )
 

#elif MANUFACTURE == CRAY

  /*
   * Single precision
   */

  #define PLA_sgemv(                              trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
             SGEMV  ( PLA_CP2FCD ( trans ),                                                                  \
                                                              m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_ssymv(                        uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
             SSYMV  ( PLA_CP2FCD ( uplo  ),                                                                  \
                                                                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_strmv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             STRMV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )
  #define PLA_strsv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             STRSV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )

  #define PLA_sger(                            m, n, alpha, x, incx, y, incy, a, lda ) \
             SGER (                           m, n, alpha, x, incx, y, incy, a, lda )
  #define PLA_ssyr(                      uplo,    n, alpha, x, incx,          a, lda ) \
             SSYR ( PLA_CP2FCD ( uplo ),                                               \
                                                 n, alpha, x, incx,          a, lda )
  #define PLA_ssyr2(                     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
             SSYR2 ( PLA_CP2FCD ( uplo ),                                              \
                                                 n, alpha, x, incx, y, incy, a, lda )

  /*
   * Double precision
   */

  #define PLA_dgemv(                              trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
             SGEMV  ( PLA_CP2FCD ( trans ),                                                                  \
                                                              m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_dsymv(                        uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
             SSYMV  ( PLA_CP2FCD ( uplo  ),                                                                  \
                                                                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_dtrmv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             STRMV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )
  #define PLA_dtrsv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             STRSV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )

  #define PLA_dger(                            m, n, alpha, x, incx, y, incy, a, lda ) \
             SGER (                           m, n, alpha, x, incx, y, incy, a, lda )
  #define PLA_dsyr(                      uplo,    n, alpha, x, incx,          a, lda ) \
             SSYR ( PLA_CP2FCD ( uplo ),                                               \
                                                 n, alpha, x, incx,          a, lda )
  #define PLA_dsyr2(                     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
             SSYR2 ( PLA_CP2FCD ( uplo ),                                              \
                                                 n, alpha, x, incx, y, incy, a, lda )

  /*
   * Single precision complex
   */

  #define PLA_cgemv(                              trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
             CGEMV  ( PLA_CP2FCD ( trans ),                                                                  \
                                                              m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_csymv(                        uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
             CSYMV  ( PLA_CP2FCD ( uplo  ),                                                                  \
                                                                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_ctrmv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             CTRMV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )
  #define PLA_ctrsv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             CTRSV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )

  #define PLA_cger(                            m, n, alpha, x, incx, y, incy, a, lda ) \
             CGER (                           m, n, alpha, x, incx, y, incy, a, lda )
  #define PLA_csyr(                      uplo,    n, alpha, x, incx,          a, lda ) \
             CSYR ( PLA_CP2FCD ( uplo ),                                               \
                                                 n, alpha, x, incx,          a, lda )
  #define PLA_csyr2(                     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
             CSYR2 ( PLA_CP2FCD ( uplo ),                                              \
                                                 n, alpha, x, incx, y, incy, a, lda )


  /*
   * Double precision complex
   */

  #define PLA_zgemv(                              trans,       m, n, alpha, a, lda, x, incx, beta, y, incy ) \
             CGEMV  ( PLA_CP2FCD ( trans ),                                                                  \
                                                              m, n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_zsymv(                        uplo,                 n, alpha, a, lda, x, incx, beta, y, incy ) \
             CSYMV  ( PLA_CP2FCD ( uplo  ),                                                                  \
                                                                 n, alpha, a, lda, x, incx, beta, y, incy )
  #define PLA_ztrmv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             CTRMV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )
  #define PLA_ztrsv(                        uplo, trans, diag,    n,        a, lda, x, incx ) \
             CTRSV  ( PLA_CP2FCD ( uplo  ),                                                   \
                      PLA_CP2FCD ( trans ),                                                   \
                      PLA_CP2FCD ( diag  ),                                                   \
                                                                 n,        a, lda, x, incx )

  #define PLA_zger(                            m, n, alpha, x, incx, y, incy, a, lda ) \
             CGER (                           m, n, alpha, x, incx, y, incy, a, lda )
  #define PLA_zsyr(                      uplo,    n, alpha, x, incx,          a, lda ) \
             CSYR ( PLA_CP2FCD ( uplo ),                                               \
                                                 n, alpha, x, incx,          a, lda )
  #define PLA_zsyr2(                     uplo,    n, alpha, x, incx, y, incy, a, lda ) \
             CSYR2 ( PLA_CP2FCD ( uplo ),                                              \
                                                 n, alpha, x, incx, y, incy, a, lda )
#endif

/*
 * Level 3 BLAS
 */

#if MANUFACTURE == INTEL || MANUFACTURE == IBM || MANUFACTURE == SUN || MANUFACTURE == PC

  /*
   * Single precision
   */

  #define           PLA_sgemm(                 transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    sgemm  ) (             transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_ssymm(     side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    ssymm  ) ( side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_ssyrk(           uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )  \
          PLA_FOR2C(    ssyrk  ) (       uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )
  #define           PLA_ssyr2k(          uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    ssyr2k ) (       uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_strmm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    strmm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )
  #define           PLA_strsm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    strsm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )

  /*
   * Double precision
   */

  #define           PLA_dgemm(                 transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    dgemm  ) (             transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_dsymm(     side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    dsymm  ) ( side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_dsyrk(           uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )  \
          PLA_FOR2C(    dsyrk  ) (       uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )
  #define           PLA_dsyr2k(          uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    dsyr2k ) (       uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_dtrmm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    dtrmm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )
  #define           PLA_dtrsm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    dtrsm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )

  /*
   * Single precision complex
   */

  #define           PLA_cgemm(                 transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    cgemm  ) (             transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_csymm(     side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    csymm  ) ( side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_chemm(     side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    chemm  ) ( side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_csyrk(           uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )  \
          PLA_FOR2C(    csyrk  ) (       uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )
  #define           PLA_cherk(           uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )  \
          PLA_FOR2C(    cherk  ) (       uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )
  #define           PLA_csyr2k(          uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    csyr2k ) (       uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_cher2k(          uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    cher2k ) (       uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_ctrmm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    ctrmm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )
  #define           PLA_ctrsm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    ctrsm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )

  /*
   * Double precision complex
   */
  #define           PLA_zgemm(                 transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    zgemm  ) (             transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_zsymm(     side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    zsymm  ) ( side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_zhemm(     side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    zhemm  ) ( side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_zsyrk(           uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )  \
          PLA_FOR2C(    zsyrk  ) (       uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )
  #define           PLA_zherk(           uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )  \
          PLA_FOR2C(    zherk  ) (       uplo, trans,                   n, k, alpha, a, lda,         beta, c, ldc )
  #define           PLA_zsyr2k(          uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    zsyr2k ) (       uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_zher2k(          uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )  \
          PLA_FOR2C(    zher2k ) (       uplo, trans,                   n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define           PLA_ztrmm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    ztrmm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )
  #define           PLA_ztrsm(     side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )  \
          PLA_FOR2C(    ztrsm  ) ( side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               )

#elif MANUFACTURE == CRAY

  /*
   * Single precision
   */

  #define PLA_sgemm(                           transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             SGEMM  ( PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( transb ),                                                                        \
                                                                    m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_ssymm(               side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc ) \
             SSYMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                    m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_ssyrk(                    uplo, trans,                    n, k, alpha, a, lda,         beta, c, ldc ) \
             SSYRK  ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda,         beta, c, ldc )
  #define PLA_ssyr2k(                   uplo, trans,                    n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             SSYR2K ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_strmm(               side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               ) \
             STRMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                    m, n,     alpha, a, lda, b, ldb              )
  #define PLA_strsm(               side, uplo, transa,         diag, m, n,     alpha, a, lda, b, ldb              ) \
             STRSM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )

  /*
   * Double precision
   */
  #define PLA_dgemm(                           transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             SGEMM  ( PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( transb ),                                                                        \
                                                                    m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_dsymm(               side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc ) \
             SSYMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                    m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_dsyrk(                    uplo, trans,                    n, k, alpha, a, lda,         beta, c, ldc ) \
             SSYRK  ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda,         beta, c, ldc )
  #define PLA_dsyr2k(                   uplo, trans,                    n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             SSYR2K ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_dtrmm(               side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               ) \
             STRMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )
  #define PLA_dtrsm(               side, uplo, transa,        diag, m, n,     alpha, a, lda, b, ldb               ) \
             STRSM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )

   /*
    * Single precision complex
    */
  #define PLA_cgemm(                           transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             CGEMM  ( PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( transb ),                                                                        \
                                                                    m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_csymm(               side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc ) \
             CSYMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                    m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_cher2(               uplo,                          n, alpha, x, incx, y,incy,  a, lda ) \
             CHER2  (                                                                       \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                       n, alpha, x, incx, y,incy,  a, lda )
  #define PLA_cher(               uplo,                          n, alpha, x, incx,          a, lda ) \
             CHER   (                                                                       \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                       n, alpha, x, incx,          a, lda )
  #define PLA_csyrk(                    uplo, trans,                    n, k, alpha, a, lda,         beta, c, ldc ) \
             CSYRK  ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda,         beta, c, ldc )
  #define PLA_cherk(                    uplo, trans,                    n, k, alpha, a, lda,         beta, c, ldc ) \
             CHERK  ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda,         beta, c, ldc )
  #define PLA_csyr2k(                   uplo, trans,                    n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             CSYR2K ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_cher2k(                   uplo, trans,                    n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             CHER2K ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_ctrmm(               side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               ) \
             CTRMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )
  #define PLA_ctrsm(               side, uplo, transa,        diag, m, n,     alpha, a, lda, b, ldb               ) \
             CTRSM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )

  /*
   * double precision complex
   */
  #define PLA_zgemm(                           transa, transb,       m, n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             CGEMM  ( PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( transb ),                                                                        \
                                                                    m, n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_zsymm(               side, uplo,                       m, n,    alpha, a, lda, b, ldb, beta, c, ldc ) \
             CSYMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                    m, n,    alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_zher(               uplo,                        n, alpha, x, incx,          a, lda ) \
             CHER   (                                                                       \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                                                                     n, alpha, x, incx,          a, lda )
  #define PLA_zsyrk(                    uplo, trans,                    n, k, alpha, a, lda,         beta, c, ldc ) \
             CSYRK  ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda,         beta, c, ldc )
  #define PLA_zherk(                    uplo, trans,                    n, k, alpha, a, lda,         beta, c, ldc ) \
             CHERK  ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda,         beta, c, ldc )
  #define PLA_zsyr2k(                   uplo, trans,                    n, k, alpha, a, lda, b, ldb, beta, c, ldc ) \
             CSYR2K ( PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( trans  ),                                                                        \
                                                                       n, k, alpha, a, lda, b, ldb, beta, c, ldc )
  #define PLA_zher2(                   uplo, n, alpha, x, incx, y, incy, a, lda        ) \
             CHER2K ( PLA_CP2FCD ( uplo   ),                                                                        \
                                                                       n, alpha, x, incx, y, incy, a, lda        )
  #define PLA_ztrmm(               side, uplo, transa,         diag, m, n,    alpha, a, lda, b, ldb               ) \
             CTRMM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )
  #define PLA_ztrsm(               side, uplo, transa,        diag, m, n,     alpha, a, lda, b, ldb               ) \
             CTRSM  ( PLA_CP2FCD ( side   ),                                                                        \
                      PLA_CP2FCD ( uplo   ),                                                                        \
                      PLA_CP2FCD ( transa ),                                                                        \
                      PLA_CP2FCD ( diag   ),                                                                        \
                                                                   m, n,     alpha, a, lda, b, ldb               )


#endif


