
/***************************************************************************
  20 June 1996 1:00pm
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by: 
  Robert van de Geijn, Department of Computer Sciences
  University of Texas at Austin  78712.    rvdg@cs.utexas.edu
  
  Philip A. Alpatov  philip@physics.utexas.edu

***************************************************************************/


#include "PLA.h"
#include "PLA_BLAS.h"
#include "MISC_DEFS.h"
/*
 * PLA_Local_gemv
 */


int PLA_Local_ger( PLA_Obj alpha,
		    PLA_Obj x,
		    PLA_Obj y,
		    PLA_Obj a)
/* 
   compute local part of
                                 T
                 y = alpha  x * y

*/                 
{
  MPI_Datatype datatype_alpha, 
               datatype_a;

  int          i_one = 1,
               local_length_a,
               local_width_a,
               a_lld,
               error;

  void        *buffer_x,
              *buffer_y,
              *buffer_a,
              *buffer_alpha;



  PLA_Matrix_local_all( a, &datatype_a, &local_length_a, &local_width_a,
		      &buffer_a, &a_lld);
  PLA_Obj_local_buffer( x, &buffer_x);
  PLA_Obj_local_buffer( y, &buffer_y);
  PLA_Obj_local_buffer(alpha, &buffer_alpha);


  if ( MPI_FLOAT == datatype_a )
    if ( local_width_a > 0 && local_length_a > 0) 
      PLA_sger ( &local_length_a, &local_width_a, 
		   buffer_alpha, buffer_x, &i_one, 
		   buffer_y, &i_one, buffer_a, &a_lld);
    else
      PLA_Zero_loc_obj(a);
  if (MPI_DOUBLE == datatype_a)
    if ( local_width_a > 0 && local_length_a > 0) 
      PLA_dger ( &local_length_a, &local_width_a, 
		   buffer_alpha, buffer_x, &i_one, 
		   buffer_y, &i_one, buffer_a, &a_lld);
    else
      PLA_Zero_loc_obj(a);    
}

