/* ---------------------------------------------------------------------
Author:     H. Carter Edwards
		http://www.ticam.utexas.edu/~carter
		carter@ticam.utexas.edu

Copyright:  Copyright (C) 1996   H. Carter Edwards

Purpose:    Asynchronous message management for MPI

License:    See 'License.Gnu'

Mail:
	University of Texas at Austin
	TICAM, TAY 2.400
	2313 Speedway
	Austin, TX  78712

Disclaimer:

    MMPI comes with ABSOLUTELY NO WARRANTY; for details read
    the file License.Gnu that came with this library.
    This is free software, and you are welcome to redistribute it
    under certain conditions, i.e. read the file 'License.Gnu'.
--------------------------------------------------------------------- */

#include "mmpi.h"
#include <fstream.h>

ostream & MMPI_Log_stream( void )
{
  static ofstream * Log_stream = NULL ;

  if ( ! Log_stream ) {
    int fd = MMPI_Log_file_d();
    if ( -1 != fd ) Log_stream = new ofstream( fd );
  }

  if ( ! *Log_stream ) {
    ( cerr << "MMPI_Log_stream open/attach error" << endl ).flush();
    return cerr ;
  }
  else {
    return *Log_stream ;
  }
}

