
/***************************************************************************
  03 April 1996 10:11
  
  Copyright (c) 1996 Robert van de Geijn and The University of Texas at Austin.
  See the file GNU_LICENSE for details on the gnu license

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Written by:   Many People including:

  Gregory A. Baker, Center for Space Research,
  University of Texas at Austin  78722      baker@csr.utexas.edu

  Philip A. Alpatov, Department of Physics,
  University of Texas at Austin 78712.     philip@physics.utexas.edu

  James Overfelt, Department of Mathematics,
  University of Texas at Austin  78712.    overfelt@@math.utexas.edu
  
  John Andrew Gunnels, Department of Computer Sciences,
  University of Texas at Austin 78712.     gunnels@@cs.utexas.edu
  
  Greg Morrow, Department of Physics, 
  University of Texas at Austin 78712.     morrow@@physics.utexas.edu
 
  Dr. Robert Van de Geijn, Department of Computer Sciences,
  University of Texas at Austin 78712.     rvdg@@cs.utexas.edu
 
***************************************************************************/







#include "PLA.h"

int PLA_Zero_loc_obj(PLA_Obj laobj)
{
  int
    i,j,
    m,n,
    lld;

  MPI_Datatype
    datatype;

  void
    *buffer = NULL;

  PLA_Obj_local_buffer(laobj, &buffer);
  PLA_Obj_datatype(laobj, &datatype);
  PLA_Obj_local_length(laobj, &m);
  PLA_Obj_local_width(laobj, &n);
  PLA_Obj_local_ldim(laobj, &lld);
  if(MPI_DOUBLE == datatype)
    {
      for(i=0; i<m; i++)
	{
	  for(j=0; j<n; j++)
	    {
	      ((double *)buffer)[j*lld + i] = 0.0;
	    }
	}
    }
  else if (MPI_FLOAT == datatype)
    {
      for(i=0; i<m; i++)
	{
	  for(j=0; j<n; j++)
	    {
	      ((float *)buffer)[j*lld + i] = 0.0;
	    }
	}
    }
  else
    printf("illegal datatype in PLA_Zero_loc_obj\n");

  return 0;
}
