/* PRISM include file */

#include "PRISM_final_list.h"

/* machine type (choices: SP2, SUN) */
#define MACHINE SP2 

/* print debug info */
#define DB_GLOBAL_NO
#define ROOT 0

/* macro definitions */
#define MAX(x,y) ( (x) > (y) ? (x) : (y) )
#define MIN(x,y) ( (x) < (y) ? (x) : (y) )
#define ABS(x)   ((x) < 0 ? -(x) : (x))
#define SIGN(x)  ((x) < 0 ? -1.0 : 1.0)

/* owner node */
int me;

/* we need to fix these up */
#define PRISM_SIZE_FINISH 4
#define PRISM_MAX_ITER_BETA 50
#define PRISM_MAX_BETA_ACCEL 6
#define EPSC 1.46e-11
#define EPSBKUP 1.49e-8

/* these should probably come from somewhere else */
#define TRUE 1

PLA_Obj PRISM_zero;
PLA_Obj PRISM_one;
PLA_Obj PRISM_mone;

/* main syisda routines */
void PRISM_init(PLA_Template template);
void PRISM_syisda(PLA_Obj A, PLA_Obj Z, PLA_Obj D, int cut_off);
void PRISM_divide(PLA_Obj Scur, PLA_Obj Zcur, PLA_Obj Dcur, PLA_Obj cur_est, 
    int cut_off, PRISM_final_list final_list);
void PRISM_end_game(PRISM_final_list final_list);
void PRISM_print_result(PLA_Obj A, PLA_Obj Z, PLA_Obj D);

/* syisda subroutines */
void PRISM_accel( PLA_Obj Stemp );
void PRISM_beta( PLA_Obj Stemp, PLA_Obj Sbeta, PLA_Obj temp );
int  PRISM_clustered( PLA_Obj lambda_min, PLA_Obj lambda_max, PLA_Obj cur_est );
void PRISM_count_at( PLA_Obj Stemp, int* n_0, int* n_half, int* n_1 );
void PRISM_deal_with_cluster( PLA_Obj Scur, PLA_Obj Dcur );
void PRISM_enter_on_final_list(PLA_Obj Scur, PLA_Obj Zcur, PLA_Obj Dcur,
     PRISM_final_list final_list);
void PRISM_find_subspaces( PLA_Obj Stemp, PLA_Obj Ztemp );
int  PRISM_iter_beta_converged( PLA_Obj Sbeta, PLA_Obj Stemp, int iterno );
void PRISM_map_half( PLA_Obj Stemp, int *n_0, int *n_half, int *n_1 );
void PRISM_mean( PLA_Obj Scur, PLA_Obj lambda_mean );
void PRISM_range( PLA_Obj Scur, PLA_Obj lambda_min, PLA_Obj lambda_max );
void PRISM_scale_shift( PLA_Obj Stemp, PLA_Obj lambda_min, \
	 PLA_Obj lambda_mean, PLA_Obj lambda_max );
void PRISM_split_into_subproblems( PLA_Obj X, int n_1, PLA_Obj Q, \
	 PLA_Obj Z, PLA_Obj Y );

/* full to band reduce and rrdiag routines */
void prism_pla_sbndrd(PLA_Obj A, PLA_Obj Q, int nb, int bnd );
void prism_pla_trisvd(PLA_Obj A, PLA_Obj Q );
int mowner(PLA_Obj x);
/* misc utilities */
double PRISM_mscalar( PLA_Obj alpha );
void PRISM_print( PLA_Obj X );
void PRISM_long_print( PLA_Obj X );
void prism_pla_prt_Qresid( PLA_Obj Temp, double *resid );

/* misc math routines */
void PRISM_max( PLA_Obj X, PLA_Obj alpha );
void PRISM_min( PLA_Obj X, PLA_Obj alpha );
void PRISM_sum( PLA_Obj X, PLA_Obj alpha );
void PRISM_abs( PLA_Obj X, PLA_Obj Y );
void PRISM_asum( PLA_Obj X, PLA_Obj Y );
void PRISM_trace( PLA_Obj X, PLA_Obj alpha );
void PRISM_norm1( PLA_Obj X, PLA_Obj alpha );
void PRISM_trans( PLA_Obj X, PLA_Obj T );
void PRISM_get_diag( PLA_Obj X, PLA_Obj D );
void PRISM_set_diag( PLA_Obj X, PLA_Obj D );
void PRISM_add_to_diag( PLA_Obj alpha, PLA_Obj X );
void PRISM_set_to_ident( PLA_Obj X );
void PRISM_sym( PLA_Obj X );

/* global definitions used in SBNDRD */
double BRDEPS;

/* fortran calls */
#if MACHINE == SP2
#define prism_pla_dschr2_ prism_pla_dschr2
#define dlamch_ dlamch
#define dsyev_ dsyev
#elif MACHINE == SUN
/* do nothing */
#endif
extern double dlamch_(char* cmach);

/* timing variables */
#define PRISM_TIME 8
#define t_setup 0
#define t_range 1
#define t_shift 2
#define t_beta 3
#define t_sbr 4
#define t_split 5
#define t_end 6
#define t_test 7
double t_syisda[PRISM_TIME];
